'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _overlay = require('../overlay');

var _overlay2 = _interopRequireDefault(_overlay);

var _style = require('./style');

var _style2 = _interopRequireDefault(_style);

var Drawer = function Drawer(props) {
  var className = _style2['default'].root + ' ' + _style2['default'][props.type];
  if (props.active) className += ' ' + _style2['default'].active;
  if (props.className) className += ' ' + props.className;

  return _react2['default'].createElement(
    _overlay2['default'],
    { active: props.active, onClick: props.onOverlayClick },
    _react2['default'].createElement(
      'div',
      { 'data-react-toolbox': 'drawer', className: className },
      _react2['default'].createElement(
        'aside',
        { className: _style2['default'].content },
        props.children
      )
    )
  );
};

Drawer.propTypes = {
  active: _react2['default'].PropTypes.bool,
  className: _react2['default'].PropTypes.string,
  onOverlayClick: _react2['default'].PropTypes.func,
  type: _react2['default'].PropTypes.oneOf(['left', 'right'])
};

Drawer.defaultProps = {
  active: false,
  className: '',
  type: 'left'
};

exports['default'] = Drawer;
module.exports = exports['default'];